Ball myBall;
Paddle myPaddle;
boolean hitPaddle;
boolean hitBoundary;
 
void setup()
{
  size(500, 500);
  rectMode(CENTER);
  ellipseMode(CENTER);
  fill(#FFFFFF);
  noStroke();
  smooth();
  
  myPaddle = new Paddle();
  myBall = new Ball();
}
 
void draw()
{
  background(#000000);
  myBall.display();
  myPaddle.display();
  myBall.move();
  paddleCollision();
  boundaryCollision();
  
  if (hitPaddle || hitBoundary) {myBall.changeDir(); }
}

final class Ball
{
  float xpos = width;
  float ypos = random(0,height);
  float xdir = -3;
  float ydir = random(1,5);
  int sizeBall =25;
 
  void display()
  {
    ellipse(xpos, ypos, sizeBall, sizeBall);
  }
 
  void move()
  {
    xpos += xdir*2;
    ypos += ydir;
  }
 
  void changeDir()
  {
    if (ypos >= height || ypos <= 0) { ydir *= -1; }
    else if(xpos >= width || xpos <= 0) { xdir *= -1; }
    else {xdir *= -1; }
  }

}
 
final class Paddle
{
  float xpos = 35;
  float ypos = height/2;
  int wPaddle = 10;
  int hPaddle = 80;
 
  void display()
  {
    rect(xpos, ypos, wPaddle, hPaddle);
  }
}

 
void boundaryCollision()
{
  if (myBall.ypos >= height || myBall.ypos <= 0) {hitBoundary = true; }
  else if (myBall.xpos >= width || myBall.xpos <= 0) {hitBoundary = true; }
  else {hitBoundary = false;}
}
 
void paddleCollision()
{
  if (myBall.xpos <= myPaddle.xpos && myBall.xdir< 0 ){
      if(myBall.ypos <= myPaddle.ypos + (myPaddle.hPaddle/2) && myBall.ypos > myPaddle.ypos - (myPaddle.hPaddle/2)) {
      hitPaddle = true;
      }
   }else{
      hitPaddle = false;
   }
}

void mouseMoved()
{
  float hOffset = myPaddle.hPaddle / 2;
  myPaddle.ypos = constrain(mouseY, 0 + hOffset, height - hOffset);
}
