import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Yun_p0B extends PApplet {

Ball myBall;
Paddle myPaddle;
boolean hitPaddle;
boolean hitBoundary;
 
public void setup()
{
  size(500, 500);
  rectMode(CENTER);
  ellipseMode(CENTER);
  fill(0xffFFFFFF);
  noStroke();
  smooth();
  
  myPaddle = new Paddle();
  myBall = new Ball();
}
 
public void draw()
{
  background(0xff000000);
  myBall.display();
  myPaddle.display();
  myBall.move();
  paddleCollision();
  boundaryCollision();
  
  if (hitPaddle || hitBoundary) {myBall.changeDir(); }
}

final class Ball
{
  float xpos = width;
  float ypos = random(0,height);
  float xdir = -3;
  float ydir = random(1,5);
  int sizeBall =25;
 
  public void display()
  {
    ellipse(xpos, ypos, sizeBall, sizeBall);
  }
 
  public void move()
  {
    xpos += xdir*2;
    ypos += ydir;
  }
 
  public void changeDir()
  {
    if (ypos >= height || ypos <= 0) { ydir *= -1; }
    else if(xpos >= width || xpos <= 0) { xdir *= -1; }
    else {xdir *= -1; }
  }

}
 
final class Paddle
{
  float xpos = 35;
  float ypos = height/2;
  int wPaddle = 10;
  int hPaddle = 80;
 
  public void display()
  {
    rect(xpos, ypos, wPaddle, hPaddle);
  }
}

 
public void boundaryCollision()
{
  if (myBall.ypos >= height || myBall.ypos <= 0) {hitBoundary = true; }
  else if (myBall.xpos >= width || myBall.xpos <= 0) {hitBoundary = true; }
  else {hitBoundary = false;}
}
 
public void paddleCollision()
{
  if (myBall.xpos <= myPaddle.xpos && myBall.xdir< 0 ){
      if(myBall.ypos <= myPaddle.ypos + (myPaddle.hPaddle/2) && myBall.ypos > myPaddle.ypos - (myPaddle.hPaddle/2)) {
      hitPaddle = true;
      }
   }else{
      hitPaddle = false;
   }
}

public void mouseMoved()
{
  float hOffset = myPaddle.hPaddle / 2;
  myPaddle.ypos = constrain(mouseY, 0 + hOffset, height - hOffset);
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "Yun_p0B" });
  }
}
